#include "addressspace.h"

namespace domain {

AddressSpace::AddressSpace(std::string name, long long start, long long end):
    name(name), start(start), end(end)
{}

std::string AddressSpace::getName() {
    return name;
}
long long AddressSpace::getStart() {
    return start;
}
long long AddressSpace::getEnd() {
    return end;
}

bool AddressSpace::contains(long long int address) {
    return address >= start && address < end;
}

bool AddressSpace::contains(long long int pstart, long long int pend) {
    return pstart >= start && pend < end;
}

} // namespace domain
