#include "connectioninstance.h"

namespace domain {


ConnectionInstance::ConnectionInstance(ComponentInstance *instance, std::vector<InstanceAttribute*> attributes, WireInstance *wire, Connection connection)
    : instance(instance), attributes(attributes), connection(connection), wire(wire)
{}

BusConnectionInstance::BusConnectionInstance(ComponentInstance *instance, std::vector<InstanceAttribute*> attributes, BusInstance *bus, WireInstance *wire, Connection connection)
    : ConnectionInstance(instance, attributes, wire, connection), bus(bus)
{}

DirectConnectionInstance::DirectConnectionInstance(ComponentInstance *instance, ComponentInstance *secondInstance, std::vector<InstanceAttribute*> attributes, BusInstance *bus, WireInstance *wire, Connection connection)
    : ConnectionInstance(instance, attributes, wire, connection), secondInstance(secondInstance), bus(bus)
{}

} // namespace domain
